
//#include <iostream>
//#include <map>       // dict from node pairs to arcs
//#include <algorithm> // sort
//#include <utility>

#include <lemon/list_graph.h>
#include <lemon/smart_graph.h>
#include <lemon/static_graph.h>

#include <lemon/network_simplex.h>
#include <lemon/cost_scaling.h>
#include <lemon/capacity_scaling.h>
#include <lemon/cycle_canceling.h>

#include <pybind11/pybind11.h>
#include <pybind11/numpy.h>

namespace py = pybind11;

using namespace lemon;
using namespace std;

PYBIND11_MODULE(lemonpy, m) {

  m.doc() = "python bindings to the c++ based lemon graph library";

  // LIST DIGRAPH

  py::module list_digraph = m.def_submodule(
      "list_digraph",
      "Provides the ListDigraph type and corresponding solvers."
  );

  py::class_<ListDigraph> graph(list_digraph, "ListDigraph");

  graph
    .def(py::init<>())
    // ListDigraph interface
    .def("addNode", &ListDigraph::addNode, "Add a new node to the digraph.")
    .def("addArc", &ListDigraph::addArc)
    .def("erase", py::overload_cast<ListDigraph::Node>(&ListDigraph::erase))
    .def("erase", py::overload_cast<ListDigraph::Arc>(&ListDigraph::erase))
    .def("valid", py::overload_cast<ListDigraph::Node>(&ListDigraph::valid, py::const_))
    .def("valid", py::overload_cast<ListDigraph::Arc>(&ListDigraph::valid, py::const_))
    .def("changeTarget", &ListDigraph::changeTarget)
    .def("changeSource", &ListDigraph::changeSource)
    .def("reverseArc", &ListDigraph::reverseArc)
    .def("contract", &ListDigraph::contract)
    .def("split", py::overload_cast<ListDigraph::Node, bool>(&ListDigraph::split))
    .def("split", py::overload_cast<ListDigraph::Arc>(&ListDigraph::split))
    .def("clear", &ListDigraph::clear)
    .def("reserveNode", &ListDigraph::reserveNode)
    .def("reserveArc", &ListDigraph::reserveArc);

  //
  // the following code was generated by 'genbindings.py'
  //

  graph
    .def("id", py::overload_cast<ListDigraph::Node>(&ListDigraph::id), "The ID of the node.")
    .def("id", py::overload_cast<ListDigraph::Arc>(&ListDigraph::id), "The ID of the arc.")
    .def("nodeFromId", &ListDigraph::nodeFromId, "The node with the given ID.")
    .def("arcFromId", &ListDigraph::arcFromId, "The arc with the given ID.")
    .def("oppositeNode", &ListDigraph::oppositeNode, "The opposite node on the arc.")
    .def("source", &ListDigraph::source, "The source node of the arc.")
    .def("target", &ListDigraph::target, "The target node of the arc.");

  py::class_<ListDigraph::Node>(list_digraph, "Node");
  py::class_<ListDigraph::Arc>(list_digraph, "Arc");
  

  py::class_<ListDigraph::NodeMap<int>>(list_digraph, "NodeMap")
    .def(py::init<const ListDigraph &>())
    .def("set", &ListDigraph::NodeMap<int>::set)
    .def("__setitem__", &ListDigraph::NodeMap<int>::set)
    .def("get", py::overload_cast<const ListDigraph::Node &>(&ListDigraph::NodeMap<int>::operator[], py::const_))
    .def("__getitem__", py::overload_cast<const ListDigraph::Node &>(&ListDigraph::NodeMap<int>::operator[], py::const_));
  

  py::class_<ListDigraph::ArcMap<int>>(list_digraph, "ArcMap")
    .def(py::init<const ListDigraph &>())
    .def("set", &ListDigraph::ArcMap<int>::set)
    .def("__setitem__", &ListDigraph::ArcMap<int>::set)
    .def("get", py::overload_cast<const ListDigraph::Arc &>(&ListDigraph::ArcMap<int>::operator[], py::const_))
    .def("__getitem__", py::overload_cast<const ListDigraph::Arc &>(&ListDigraph::ArcMap<int>::operator[], py::const_));
  

  py::class_<NetworkSimplex<ListDigraph, int>> solver0(list_digraph, "NetworkSimplex");
  solver0
    .def(py::init<const ListDigraph &>())
    // setup
    .def("lowerMap", &NetworkSimplex<ListDigraph, int>::lowerMap<ListDigraph::ArcMap<int>>, "Set the lower bounds on the arcs.")
    .def("upperMap", &NetworkSimplex<ListDigraph, int>::upperMap<ListDigraph::ArcMap<int>>, "Set the upper bounds (capacities) on the arcs.")
    .def("costMap", &NetworkSimplex<ListDigraph, int>::costMap<ListDigraph::ArcMap<int>>, "Set the costs of the arcs.")
    .def("supplyMap", &NetworkSimplex<ListDigraph, int>::supplyMap<ListDigraph::NodeMap<int>>, "Set the supply values of the nodes.")
    // running and resetting
    .def("run", &NetworkSimplex<ListDigraph, int>::run, "Run the algorithm.")
    .def("resetParams", &NetworkSimplex<ListDigraph, int>::resetParams, "Reset all the parameters that have been given before.")
    .def("reset", &NetworkSimplex<ListDigraph, int>::reset, "Reset the internal data structures and all the parameters that have been given before.")
    // query results
    .def("totalCost", &NetworkSimplex<ListDigraph, int>::totalCost<double>, "Return the total cost of the found flow.")
    .def("flow", &NetworkSimplex<ListDigraph, int>::flow, "Return the flow on the given arc.")
    .def("potential", &NetworkSimplex<ListDigraph, int>::potential, "Return the flow map (the primal solution).")
    .def("flowMap", &NetworkSimplex<ListDigraph, int>::flowMap<ListDigraph::ArcMap<int>>, "Return the potential (dual value) of the given node.")
    .def("potentialMap", &NetworkSimplex<ListDigraph, int>::potentialMap<ListDigraph::NodeMap<int>>, "Return the potential map (the dual solution).");
    
  py::enum_<NetworkSimplex<ListDigraph, int>::ProblemType>(solver0, "ProblemType")
    .value("INFEASIBLE", NetworkSimplex<ListDigraph, int>::ProblemType::INFEASIBLE)
    .value("OPTIMAL", NetworkSimplex<ListDigraph, int>::ProblemType::OPTIMAL)
    .value("UNBOUNDED", NetworkSimplex<ListDigraph, int>::ProblemType::UNBOUNDED);

  py::enum_<NetworkSimplex<ListDigraph, int>::PivotRule>(solver0, "PivotRule")
    .value("FIRST_ELIGIBLE", NetworkSimplex<ListDigraph, int>::PivotRule::FIRST_ELIGIBLE)
    .value("BEST_ELIGIBLE", NetworkSimplex<ListDigraph, int>::PivotRule::BEST_ELIGIBLE)
    .value("BLOCK_SEARCH", NetworkSimplex<ListDigraph, int>::PivotRule::BLOCK_SEARCH)
    .value("CANDIDATE_LIST", NetworkSimplex<ListDigraph, int>::PivotRule::CANDIDATE_LIST)
    .value("ALTERING_LIST", NetworkSimplex<ListDigraph, int>::PivotRule::ALTERING_LIST);

  py::enum_<NetworkSimplex<ListDigraph, int>::SupplyType> (solver0, "SupplyType")
    .value("GEQ", NetworkSimplex<ListDigraph, int>::SupplyType::GEQ)
    .value("LEQ", NetworkSimplex<ListDigraph, int>::SupplyType::LEQ);
  

  py::class_<CostScaling<ListDigraph, int>> solver1(list_digraph, "NetworkSimplex");
  solver1
    .def(py::init<const ListDigraph &>())
    // setup
    .def("lowerMap", &CostScaling<ListDigraph, int>::lowerMap<ListDigraph::ArcMap<int>>, "Set the lower bounds on the arcs.")
    .def("upperMap", &CostScaling<ListDigraph, int>::upperMap<ListDigraph::ArcMap<int>>, "Set the upper bounds (capacities) on the arcs.")
    .def("costMap", &CostScaling<ListDigraph, int>::costMap<ListDigraph::ArcMap<int>>, "Set the costs of the arcs.")
    .def("supplyMap", &CostScaling<ListDigraph, int>::supplyMap<ListDigraph::NodeMap<int>>, "Set the supply values of the nodes.")
    // running and resetting
    .def("run", &CostScaling<ListDigraph, int>::run, "Run the algorithm.")
    .def("resetParams", &CostScaling<ListDigraph, int>::resetParams, "Reset all the parameters that have been given before.")
    .def("reset", &CostScaling<ListDigraph, int>::reset, "Reset the internal data structures and all the parameters that have been given before.")
    // query results
    .def("totalCost", &CostScaling<ListDigraph, int>::totalCost<double>, "Return the total cost of the found flow.")
    .def("flow", &CostScaling<ListDigraph, int>::flow, "Return the flow on the given arc.")
    .def("potential", &CostScaling<ListDigraph, int>::potential, "Return the flow map (the primal solution).")
    .def("flowMap", &CostScaling<ListDigraph, int>::flowMap<ListDigraph::ArcMap<int>>, "Return the potential (dual value) of the given node.")
    .def("potentialMap", &CostScaling<ListDigraph, int>::potentialMap<ListDigraph::NodeMap<int>>, "Return the potential map (the dual solution).");

  py::enum_<CostScaling<ListDigraph, int>::ProblemType>(solver1, "ProblemType")
    .value("INFEASIBLE", CostScaling<ListDigraph, int>::ProblemType::INFEASIBLE)
    .value("OPTIMAL", CostScaling<ListDigraph, int>::ProblemType::OPTIMAL)
    .value("UNBOUNDED", CostScaling<ListDigraph, int>::ProblemType::UNBOUNDED);

  py::enum_<CostScaling<ListDigraph, int>::Method>(solver1, "Method")
    .value("PUSH", CostScaling<ListDigraph, int>::Method::PUSH)
    .value("AUGMENT", CostScaling<ListDigraph, int>::Method::AUGMENT)
    .value("PARTIAL_AUGMENT", CostScaling<ListDigraph, int>::Method::PARTIAL_AUGMENT);
  

  py::class_<CapacityScaling<ListDigraph, int>> solver2(list_digraph, "CapacityScaling");
  solver2
    .def(py::init<const ListDigraph &>())
    // setup
    .def("lowerMap", &CapacityScaling<ListDigraph, int>::lowerMap<ListDigraph::ArcMap<int>>, "Set the lower bounds on the arcs.")
    .def("upperMap", &CapacityScaling<ListDigraph, int>::upperMap<ListDigraph::ArcMap<int>>, "Set the upper bounds (capacities) on the arcs.")
    .def("costMap", &CapacityScaling<ListDigraph, int>::costMap<ListDigraph::ArcMap<int>>, "Set the costs of the arcs.")
    .def("supplyMap", &CapacityScaling<ListDigraph, int>::supplyMap<ListDigraph::NodeMap<int>>, "Set the supply values of the nodes.")
    // running and resetting
    .def("run", &CapacityScaling<ListDigraph, int>::run, "Run the algorithm.")
    .def("resetParams", &CapacityScaling<ListDigraph, int>::resetParams, "Reset all the parameters that have been given before.")
    .def("reset", &CapacityScaling<ListDigraph, int>::reset, "Reset the internal data structures and all the parameters that have been given before.")
    // query results
    .def("totalCost", &CapacityScaling<ListDigraph, int>::totalCost<double>, "Return the total cost of the found flow.")
    .def("flow", &CapacityScaling<ListDigraph, int>::flow, "Return the flow on the given arc.")
    .def("potential", &CapacityScaling<ListDigraph, int>::potential, "Return the flow map (the primal solution).")
    .def("flowMap", &CapacityScaling<ListDigraph, int>::flowMap<ListDigraph::ArcMap<int>>, "Return the potential (dual value) of the given node.")
    .def("potentialMap", &CapacityScaling<ListDigraph, int>::potentialMap<ListDigraph::NodeMap<int>>, "Return the potential map (the dual solution).");
    
  py::enum_<CapacityScaling<ListDigraph, int>::ProblemType>(solver2, "ProblemType")
    .value("INFEASIBLE", CapacityScaling<ListDigraph, int>::ProblemType::INFEASIBLE)
    .value("OPTIMAL", CapacityScaling<ListDigraph, int>::ProblemType::OPTIMAL)
    .value("UNBOUNDED", CapacityScaling<ListDigraph, int>::ProblemType::UNBOUNDED);
  

  py::class_<CycleCanceling<ListDigraph, int>> solver3(list_digraph, "CycleCanceling");
  solver3
    .def(py::init<const ListDigraph &>())
    // setup
    .def("lowerMap", &CycleCanceling<ListDigraph, int>::lowerMap<ListDigraph::ArcMap<int>>, "Set the lower bounds on the arcs.")
    .def("upperMap", &CycleCanceling<ListDigraph, int>::upperMap<ListDigraph::ArcMap<int>>, "Set the upper bounds (capacities) on the arcs.")
    .def("costMap", &CycleCanceling<ListDigraph, int>::costMap<ListDigraph::ArcMap<int>>, "Set the costs of the arcs.")
    .def("supplyMap", &CycleCanceling<ListDigraph, int>::supplyMap<ListDigraph::NodeMap<int>>, "Set the supply values of the nodes.")
    // running and resetting
    .def("run", &CycleCanceling<ListDigraph, int>::run, "Run the algorithm.")
    .def("resetParams", &CycleCanceling<ListDigraph, int>::resetParams, "Reset all the parameters that have been given before.")
    .def("reset", &CycleCanceling<ListDigraph, int>::reset, "Reset the internal data structures and all the parameters that have been given before.")
    // query results
    .def("totalCost", &CycleCanceling<ListDigraph, int>::totalCost<double>, "Return the total cost of the found flow.")
    .def("flow", &CycleCanceling<ListDigraph, int>::flow, "Return the flow on the given arc.")
    .def("potential", &CycleCanceling<ListDigraph, int>::potential, "Return the flow map (the primal solution).")
    .def("flowMap", &CycleCanceling<ListDigraph, int>::flowMap<ListDigraph::ArcMap<int>>, "Return the potential (dual value) of the given node.")
    .def("potentialMap", &CycleCanceling<ListDigraph, int>::potentialMap<ListDigraph::NodeMap<int>>, "Return the potential map (the dual solution).");

  py::enum_<CycleCanceling<ListDigraph, int>::ProblemType>(solver3, "ProblemType")
    .value("INFEASIBLE", CycleCanceling<ListDigraph, int>::ProblemType::INFEASIBLE)
    .value("OPTIMAL", CycleCanceling<ListDigraph, int>::ProblemType::OPTIMAL)
    .value("UNBOUNDED", CycleCanceling<ListDigraph, int>::ProblemType::UNBOUNDED);

  py::enum_<CycleCanceling<ListDigraph, int>::Method>(solver3, "Method")
    .value("SIMPLE_CYCLE_CANCELING", CycleCanceling<ListDigraph, int>::Method::SIMPLE_CYCLE_CANCELING)
    .value("MINIMUM_MEAN_CYCLE_CANCELING", CycleCanceling<ListDigraph, int>::Method::MINIMUM_MEAN_CYCLE_CANCELING)
    .value("CANCEL_AND_TIGHTEN", CycleCanceling<ListDigraph, int>::Method::CANCEL_AND_TIGHTEN);
  
  //
  // end of generated code
  //
  py::module int64 = list_digraph.def_submodule(
      "int64",
      "Provides list digraph methods with 64 bit integers."
  );

  //
  // the following code was generated by 'genbindings.py'
  //

  graph
    .def("id", py::overload_cast<ListDigraph::Node>(&ListDigraph::id), "The ID of the node.")
    .def("id", py::overload_cast<ListDigraph::Arc>(&ListDigraph::id), "The ID of the arc.")
    .def("nodeFromId", &ListDigraph::nodeFromId, "The node with the given ID.")
    .def("arcFromId", &ListDigraph::arcFromId, "The arc with the given ID.")
    .def("oppositeNode", &ListDigraph::oppositeNode, "The opposite node on the arc.")
    .def("source", &ListDigraph::source, "The source node of the arc.")
    .def("target", &ListDigraph::target, "The target node of the arc.");

  py::class_<ListDigraph::Node>(int64, "Node");
  py::class_<ListDigraph::Arc>(int64, "Arc");
  

  py::class_<ListDigraph::NodeMap<long long int>>(int64, "NodeMap")
    .def(py::init<const ListDigraph &>())
    .def("set", &ListDigraph::NodeMap<long long int>::set)
    .def("__setitem__", &ListDigraph::NodeMap<long long int>::set)
    .def("get", py::overload_cast<const ListDigraph::Node &>(&ListDigraph::NodeMap<long long int>::operator[], py::const_))
    .def("__getitem__", py::overload_cast<const ListDigraph::Node &>(&ListDigraph::NodeMap<long long int>::operator[], py::const_));
  

  py::class_<ListDigraph::ArcMap<long long int>>(int64, "ArcMap")
    .def(py::init<const ListDigraph &>())
    .def("set", &ListDigraph::ArcMap<long long int>::set)
    .def("__setitem__", &ListDigraph::ArcMap<long long int>::set)
    .def("get", py::overload_cast<const ListDigraph::Arc &>(&ListDigraph::ArcMap<long long int>::operator[], py::const_))
    .def("__getitem__", py::overload_cast<const ListDigraph::Arc &>(&ListDigraph::ArcMap<long long int>::operator[], py::const_));
  

  py::class_<NetworkSimplex<ListDigraph, long long int>> solver4(int64, "NetworkSimplex");
  solver4
    .def(py::init<const ListDigraph &>())
    // setup
    .def("lowerMap", &NetworkSimplex<ListDigraph, long long int>::lowerMap<ListDigraph::ArcMap<long long int>>, "Set the lower bounds on the arcs.")
    .def("upperMap", &NetworkSimplex<ListDigraph, long long int>::upperMap<ListDigraph::ArcMap<long long int>>, "Set the upper bounds (capacities) on the arcs.")
    .def("costMap", &NetworkSimplex<ListDigraph, long long int>::costMap<ListDigraph::ArcMap<long long int>>, "Set the costs of the arcs.")
    .def("supplyMap", &NetworkSimplex<ListDigraph, long long int>::supplyMap<ListDigraph::NodeMap<long long int>>, "Set the supply values of the nodes.")
    // running and resetting
    .def("run", &NetworkSimplex<ListDigraph, long long int>::run, "Run the algorithm.")
    .def("resetParams", &NetworkSimplex<ListDigraph, long long int>::resetParams, "Reset all the parameters that have been given before.")
    .def("reset", &NetworkSimplex<ListDigraph, long long int>::reset, "Reset the internal data structures and all the parameters that have been given before.")
    // query results
    .def("totalCost", &NetworkSimplex<ListDigraph, long long int>::totalCost<double>, "Return the total cost of the found flow.")
    .def("flow", &NetworkSimplex<ListDigraph, long long int>::flow, "Return the flow on the given arc.")
    .def("potential", &NetworkSimplex<ListDigraph, long long int>::potential, "Return the flow map (the primal solution).")
    .def("flowMap", &NetworkSimplex<ListDigraph, long long int>::flowMap<ListDigraph::ArcMap<long long int>>, "Return the potential (dual value) of the given node.")
    .def("potentialMap", &NetworkSimplex<ListDigraph, long long int>::potentialMap<ListDigraph::NodeMap<long long int>>, "Return the potential map (the dual solution).");
    
  py::enum_<NetworkSimplex<ListDigraph, long long int>::ProblemType>(solver4, "ProblemType")
    .value("INFEASIBLE", NetworkSimplex<ListDigraph, long long int>::ProblemType::INFEASIBLE)
    .value("OPTIMAL", NetworkSimplex<ListDigraph, long long int>::ProblemType::OPTIMAL)
    .value("UNBOUNDED", NetworkSimplex<ListDigraph, long long int>::ProblemType::UNBOUNDED);

  py::enum_<NetworkSimplex<ListDigraph, long long int>::PivotRule>(solver4, "PivotRule")
    .value("FIRST_ELIGIBLE", NetworkSimplex<ListDigraph, long long int>::PivotRule::FIRST_ELIGIBLE)
    .value("BEST_ELIGIBLE", NetworkSimplex<ListDigraph, long long int>::PivotRule::BEST_ELIGIBLE)
    .value("BLOCK_SEARCH", NetworkSimplex<ListDigraph, long long int>::PivotRule::BLOCK_SEARCH)
    .value("CANDIDATE_LIST", NetworkSimplex<ListDigraph, long long int>::PivotRule::CANDIDATE_LIST)
    .value("ALTERING_LIST", NetworkSimplex<ListDigraph, long long int>::PivotRule::ALTERING_LIST);

  py::enum_<NetworkSimplex<ListDigraph, long long int>::SupplyType> (solver4, "SupplyType")
    .value("GEQ", NetworkSimplex<ListDigraph, long long int>::SupplyType::GEQ)
    .value("LEQ", NetworkSimplex<ListDigraph, long long int>::SupplyType::LEQ);
  

  py::class_<CostScaling<ListDigraph, long long int>> solver5(int64, "NetworkSimplex");
  solver5
    .def(py::init<const ListDigraph &>())
    // setup
    .def("lowerMap", &CostScaling<ListDigraph, long long int>::lowerMap<ListDigraph::ArcMap<long long int>>, "Set the lower bounds on the arcs.")
    .def("upperMap", &CostScaling<ListDigraph, long long int>::upperMap<ListDigraph::ArcMap<long long int>>, "Set the upper bounds (capacities) on the arcs.")
    .def("costMap", &CostScaling<ListDigraph, long long int>::costMap<ListDigraph::ArcMap<long long int>>, "Set the costs of the arcs.")
    .def("supplyMap", &CostScaling<ListDigraph, long long int>::supplyMap<ListDigraph::NodeMap<long long int>>, "Set the supply values of the nodes.")
    // running and resetting
    .def("run", &CostScaling<ListDigraph, long long int>::run, "Run the algorithm.")
    .def("resetParams", &CostScaling<ListDigraph, long long int>::resetParams, "Reset all the parameters that have been given before.")
    .def("reset", &CostScaling<ListDigraph, long long int>::reset, "Reset the internal data structures and all the parameters that have been given before.")
    // query results
    .def("totalCost", &CostScaling<ListDigraph, long long int>::totalCost<double>, "Return the total cost of the found flow.")
    .def("flow", &CostScaling<ListDigraph, long long int>::flow, "Return the flow on the given arc.")
    .def("potential", &CostScaling<ListDigraph, long long int>::potential, "Return the flow map (the primal solution).")
    .def("flowMap", &CostScaling<ListDigraph, long long int>::flowMap<ListDigraph::ArcMap<long long int>>, "Return the potential (dual value) of the given node.")
    .def("potentialMap", &CostScaling<ListDigraph, long long int>::potentialMap<ListDigraph::NodeMap<long long int>>, "Return the potential map (the dual solution).");

  py::enum_<CostScaling<ListDigraph, long long int>::ProblemType>(solver5, "ProblemType")
    .value("INFEASIBLE", CostScaling<ListDigraph, long long int>::ProblemType::INFEASIBLE)
    .value("OPTIMAL", CostScaling<ListDigraph, long long int>::ProblemType::OPTIMAL)
    .value("UNBOUNDED", CostScaling<ListDigraph, long long int>::ProblemType::UNBOUNDED);

  py::enum_<CostScaling<ListDigraph, long long int>::Method>(solver5, "Method")
    .value("PUSH", CostScaling<ListDigraph, long long int>::Method::PUSH)
    .value("AUGMENT", CostScaling<ListDigraph, long long int>::Method::AUGMENT)
    .value("PARTIAL_AUGMENT", CostScaling<ListDigraph, long long int>::Method::PARTIAL_AUGMENT);
  

  py::class_<CapacityScaling<ListDigraph, long long int>> solver6(int64, "CapacityScaling");
  solver6
    .def(py::init<const ListDigraph &>())
    // setup
    .def("lowerMap", &CapacityScaling<ListDigraph, long long int>::lowerMap<ListDigraph::ArcMap<long long int>>, "Set the lower bounds on the arcs.")
    .def("upperMap", &CapacityScaling<ListDigraph, long long int>::upperMap<ListDigraph::ArcMap<long long int>>, "Set the upper bounds (capacities) on the arcs.")
    .def("costMap", &CapacityScaling<ListDigraph, long long int>::costMap<ListDigraph::ArcMap<long long int>>, "Set the costs of the arcs.")
    .def("supplyMap", &CapacityScaling<ListDigraph, long long int>::supplyMap<ListDigraph::NodeMap<long long int>>, "Set the supply values of the nodes.")
    // running and resetting
    .def("run", &CapacityScaling<ListDigraph, long long int>::run, "Run the algorithm.")
    .def("resetParams", &CapacityScaling<ListDigraph, long long int>::resetParams, "Reset all the parameters that have been given before.")
    .def("reset", &CapacityScaling<ListDigraph, long long int>::reset, "Reset the internal data structures and all the parameters that have been given before.")
    // query results
    .def("totalCost", &CapacityScaling<ListDigraph, long long int>::totalCost<double>, "Return the total cost of the found flow.")
    .def("flow", &CapacityScaling<ListDigraph, long long int>::flow, "Return the flow on the given arc.")
    .def("potential", &CapacityScaling<ListDigraph, long long int>::potential, "Return the flow map (the primal solution).")
    .def("flowMap", &CapacityScaling<ListDigraph, long long int>::flowMap<ListDigraph::ArcMap<long long int>>, "Return the potential (dual value) of the given node.")
    .def("potentialMap", &CapacityScaling<ListDigraph, long long int>::potentialMap<ListDigraph::NodeMap<long long int>>, "Return the potential map (the dual solution).");
    
  py::enum_<CapacityScaling<ListDigraph, long long int>::ProblemType>(solver6, "ProblemType")
    .value("INFEASIBLE", CapacityScaling<ListDigraph, long long int>::ProblemType::INFEASIBLE)
    .value("OPTIMAL", CapacityScaling<ListDigraph, long long int>::ProblemType::OPTIMAL)
    .value("UNBOUNDED", CapacityScaling<ListDigraph, long long int>::ProblemType::UNBOUNDED);
  

  py::class_<CycleCanceling<ListDigraph, long long int>> solver7(int64, "CycleCanceling");
  solver7
    .def(py::init<const ListDigraph &>())
    // setup
    .def("lowerMap", &CycleCanceling<ListDigraph, long long int>::lowerMap<ListDigraph::ArcMap<long long int>>, "Set the lower bounds on the arcs.")
    .def("upperMap", &CycleCanceling<ListDigraph, long long int>::upperMap<ListDigraph::ArcMap<long long int>>, "Set the upper bounds (capacities) on the arcs.")
    .def("costMap", &CycleCanceling<ListDigraph, long long int>::costMap<ListDigraph::ArcMap<long long int>>, "Set the costs of the arcs.")
    .def("supplyMap", &CycleCanceling<ListDigraph, long long int>::supplyMap<ListDigraph::NodeMap<long long int>>, "Set the supply values of the nodes.")
    // running and resetting
    .def("run", &CycleCanceling<ListDigraph, long long int>::run, "Run the algorithm.")
    .def("resetParams", &CycleCanceling<ListDigraph, long long int>::resetParams, "Reset all the parameters that have been given before.")
    .def("reset", &CycleCanceling<ListDigraph, long long int>::reset, "Reset the internal data structures and all the parameters that have been given before.")
    // query results
    .def("totalCost", &CycleCanceling<ListDigraph, long long int>::totalCost<double>, "Return the total cost of the found flow.")
    .def("flow", &CycleCanceling<ListDigraph, long long int>::flow, "Return the flow on the given arc.")
    .def("potential", &CycleCanceling<ListDigraph, long long int>::potential, "Return the flow map (the primal solution).")
    .def("flowMap", &CycleCanceling<ListDigraph, long long int>::flowMap<ListDigraph::ArcMap<long long int>>, "Return the potential (dual value) of the given node.")
    .def("potentialMap", &CycleCanceling<ListDigraph, long long int>::potentialMap<ListDigraph::NodeMap<long long int>>, "Return the potential map (the dual solution).");

  py::enum_<CycleCanceling<ListDigraph, long long int>::ProblemType>(solver7, "ProblemType")
    .value("INFEASIBLE", CycleCanceling<ListDigraph, long long int>::ProblemType::INFEASIBLE)
    .value("OPTIMAL", CycleCanceling<ListDigraph, long long int>::ProblemType::OPTIMAL)
    .value("UNBOUNDED", CycleCanceling<ListDigraph, long long int>::ProblemType::UNBOUNDED);

  py::enum_<CycleCanceling<ListDigraph, long long int>::Method>(solver7, "Method")
    .value("SIMPLE_CYCLE_CANCELING", CycleCanceling<ListDigraph, long long int>::Method::SIMPLE_CYCLE_CANCELING)
    .value("MINIMUM_MEAN_CYCLE_CANCELING", CycleCanceling<ListDigraph, long long int>::Method::MINIMUM_MEAN_CYCLE_CANCELING)
    .value("CANCEL_AND_TIGHTEN", CycleCanceling<ListDigraph, long long int>::Method::CANCEL_AND_TIGHTEN);
  
  //
  // end of generated code
  //
}

